package eu.etaxonomy.taxeditor.designproposal2.view;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IEditorSite;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.part.MultiPageEditorPart;

import eu.etaxonomy.taxeditor.designproposal2.model.NameEditorInput;
import eu.etaxonomy.taxeditor.designproposal2.model.TaxonName;

public class MultiPagePilosellaView extends MultiPageEditorPart {

	public static final String ID = "eu.etaxonomy.taxeditor.designproposal2.view.mpetestview";
	private TaxonName taxonname;
	
	@Override
	protected void createPages() {
		try {
			if (taxonname.getName() == "Carduus") {
				this.setPartName("Carduus L.");
				addPage(0, new CarduusEditorView(), new NameEditorInput(new TaxonName()));
			} else if (taxonname.getName() == "Pilosella") {
				this.setPartName("Pilosella fuscoatra (Ngeli & Peter) Sojk");
				addPage(0, new PilosellaEditorView(), new NameEditorInput(new TaxonName()));
			} else {
				this.setPartName("New taxon");
				addPage(0, new NameEditorView(), new NameEditorInput(new TaxonName()));				
			}
			setPageText(0, "Name");

			addPage(1, new EmptyEditorView(), new NameEditorInput(new TaxonName()));
			setPageText(1, "Facts");
			
			addPage(2, new EmptyEditorView(), new NameEditorInput(new TaxonName()));
			setPageText(2, "Specimen");
			
			addPage(3, new EmptyEditorView(), new NameEditorInput(new TaxonName()));
			setPageText(3, "Geographic");
			
		} catch (PartInitException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	@Override
	public void doSave(IProgressMonitor monitor) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void doSaveAs() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public boolean isSaveAsAllowed() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public void init(IEditorSite site, IEditorInput input) throws PartInitException {

		if (!(input instanceof IEditorInput))
			throw new PartInitException(
					"Invalid Input: Must be IFileEditorInput");
		
		if (input.getAdapter(TaxonName.class) != null) {
			taxonname = (TaxonName) input.getAdapter(TaxonName.class);
//			System.out.println(taxonname.getCreatedWho());
//			taxonname.addCdmEventListener(this);
		} else {
			
			taxonname = null;
		}
	
		
		setSite(site);
		setInput(input);
	}
	
}
