package eu.etaxonomy.taxeditor.prototype1.view;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.util.Vector;

import org.eclipse.core.databinding.Binding;
import org.eclipse.core.databinding.DataBindingContext;
import org.eclipse.core.databinding.UpdateValueStrategy;
import org.eclipse.core.databinding.beans.BeansObservables;

import org.eclipse.core.databinding.observable.map.IObservableMap;
import org.eclipse.core.databinding.observable.value.IObservableValue;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.jface.databinding.swt.SWTObservables;
import org.eclipse.jface.databinding.viewers.ObservableListContentProvider;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.jface.viewers.ColumnLabelProvider;
import org.eclipse.jface.viewers.EditingSupport;
import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.TextCellEditor;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.jface.viewers.TreeViewerColumn;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerCell;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IEditorSite;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.part.EditorPart;

import com.swtdesigner.SWTResourceManager;

import eu.etaxonomy.taxeditor.prototype1.controller.CreateNameAction;
import eu.etaxonomy.taxeditor.prototype1.controller.DeleteNameAction;
import eu.etaxonomy.taxeditor.prototype1.controller.SaveNameAction;
import eu.etaxonomy.cdm.model.name.TaxonName;

public class NameEditorView extends EditorPart {

	private Text se;
	private Text g;
	private Text txtGenus_1;
	private TaxonName taxonname;
	
	private IObservableValue observeTxtGenus;
	private IObservableValue observeTxtGenus_1;

	private Text txtGenus;
	private Text txtSpEpi;
	private Text txtAuthor;
	public static final String ID = "eu.etaxonomy.taxeditor.prototype1.view.NameEditorView"; //$NON-NLS-1$

	private Vector nodes = new Vector();
	private DataBindingContext bindingContext;
	private Binding binding;
	
	private Node genusNode;
	private IObservableValue observeGenusNode;
	private TreeViewer treeViewer;
	private TextCellEditor genusCellEditor;
	private GenericObservableMapCellLabelProvider cellLabelProvider;
	
	/**
	 * Create contents of the editor part
	 * @param parent
	 */
	@Override
	public void createPartControl(Composite parent) {

		bindingContext = new DataBindingContext();
		
		Composite container = new Composite(parent, SWT.NONE);
		final GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 3;
		container.setLayout(gridLayout);

		final Label liveUpdateLabel = new Label(container, SWT.NONE);
		liveUpdateLabel.setFont(SWTResourceManager.getFont("", 10, SWT.BOLD));
		final GridData gd_liveUpdateLabel = new GridData();
		liveUpdateLabel.setLayoutData(gd_liveUpdateLabel);
		new Label(container, SWT.NONE);
		new Label(container, SWT.NONE);

		final Label lblGenus = new Label(container, SWT.NONE);
		lblGenus.setLayoutData(new GridData());
		lblGenus.setText("Genus:");
		new Label(container, SWT.NONE);

		txtGenus = new Text(container, SWT.BORDER);
		final GridData gd_txtGenus = new GridData(SWT.FILL, SWT.CENTER, true, false);
		txtGenus.setLayoutData(gd_txtGenus);

		final Label lblSpEpi = new Label(container, SWT.NONE);
		lblSpEpi.setLayoutData(new GridData());
		lblSpEpi.setText("Sp. Epithet:");
		new Label(container, SWT.NONE);

		txtSpEpi = new Text(container, SWT.BORDER);
		final GridData gd_txtSpEpi = new GridData(SWT.FILL, SWT.CENTER, true, false);
		txtSpEpi.setLayoutData(gd_txtSpEpi);

		final Label lblAuthor = new Label(container, SWT.NONE);
		lblAuthor.setLayoutData(new GridData());
		lblAuthor.setText("Authorship:");
		new Label(container, SWT.NONE);

		txtAuthor = new Text(container, SWT.BORDER);
		final GridData gd_txtAuthor = new GridData(SWT.FILL, SWT.CENTER, true, false);
		txtAuthor.setLayoutData(gd_txtAuthor);

		final Composite container_1 = new Composite(container, SWT.NONE);
		final GridData gd_container_1 = new GridData(SWT.FILL, SWT.CENTER, true, false, 4, 1);
		gd_container_1.widthHint = 389;
		container_1.setLayoutData(gd_container_1);
		final GridLayout gridLayout_1 = new GridLayout();
		gridLayout_1.numColumns = 2;
		container_1.setLayout(gridLayout_1);

		final Label liveUpdateLabel_1 = new Label(container_1, SWT.NONE);
		final GridData gd_liveUpdateLabel_1 = new GridData();
		liveUpdateLabel_1.setLayoutData(gd_liveUpdateLabel_1);
		liveUpdateLabel_1.setFont(SWTResourceManager.getFont("", 10, SWT.BOLD));

		// create tree
		createTree(container_1);
		
		final Label lblGenus_1 = new Label(container_1, SWT.NONE);
		lblGenus_1.setLayoutData(new GridData());
		lblGenus_1.setText("Genus:");

		txtGenus_1 = new Text(container_1, SWT.BORDER);
		final GridData gd_txtGenus_1 = new GridData(SWT.FILL, SWT.CENTER, true, false);
		txtGenus_1.setLayoutData(gd_txtGenus_1);

		final Button btnSaveName_1 = new Button(container_1, SWT.NONE);
		btnSaveName_1.addMouseListener(new MouseAdapter() {
			public void mouseDown(final MouseEvent e) {
				
				taxonname.setGenus(txtGenus.getText());
				taxonname.setSpecificEpithet(txtSpEpi.getText());
				
				new SaveNameAction(taxonname).run();
			}			
		});
		final GridData gd_btnSaveName_1 = new GridData();
		btnSaveName_1.setLayoutData(gd_btnSaveName_1);
		btnSaveName_1.setText("Save Name");

		final Button deleteNameButton = new Button(container_1, SWT.NONE);
		deleteNameButton.addMouseListener(new MouseAdapter() {
			public void mouseDown(final MouseEvent e) {
				new DeleteNameAction(taxonname).run();
				txtGenus.setEditable(false);
				txtSpEpi.setEditable(false);
				txtAuthor.setEditable(false);
				txtGenus_1.setEditable(false);
				btnSaveName_1.setEnabled(false);
				deleteNameButton.setEnabled(false);
			}
		});
		deleteNameButton.setText("Delete Name");

		final Group newTaxonAreaGroup = new Group(container, SWT.NONE);
		final GridLayout gridLayout_2 = new GridLayout();
		gridLayout_2.numColumns = 2;
		newTaxonAreaGroup.setLayout(gridLayout_2);
		newTaxonAreaGroup.setText("New taxon area");
		final GridData gd_newTaxonAreaGroup = new GridData(SWT.FILL, SWT.FILL, true, true, 3, 1);
		newTaxonAreaGroup.setLayoutData(gd_newTaxonAreaGroup);

		final Label gLabel = new Label(newTaxonAreaGroup, SWT.NONE);
		gLabel.setLayoutData(new GridData());
		gLabel.setText("G");

		g = new Text(newTaxonAreaGroup, SWT.BORDER);
		g.setText("Test");
		g.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false));

		final Label seLabel = new Label(newTaxonAreaGroup, SWT.NONE);
		seLabel.setText("SE");

		se = new Text(newTaxonAreaGroup, SWT.BORDER);
		se.setText("me");
		se.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false));
		new Label(newTaxonAreaGroup, SWT.NONE);

		final Button createNewNameButton = new Button(newTaxonAreaGroup, SWT.NONE);
		createNewNameButton.addMouseListener(new MouseAdapter() {
			public void mouseDown(final MouseEvent e) {
				new CreateNameAction(g.getText(),se.getText()).run();
			}			
		});
		createNewNameButton.setText("Create New Name");

		final Group group = new Group(container, SWT.NONE);
		group.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 3, 1));
		group.setLayout(new GridLayout());

		
		
//		txtPlay = new Text(container, SWT.BORDER);
//		txtPlay.setCapture(true);
//		final GridData gd_txtPlay = new GridData(SWT.FILL, SWT.CENTER, true, false, 2, 1);
//		gd_txtPlay.heightHint = 96;
//		txtPlay.setLayoutData(gd_txtPlay);
////		txtPlay.addVerifyListener(new VerifyListener() {
////			@Override
////			public void verifyText(VerifyEvent e) {
////		        e.doit = Character.isDigit(e.character);
////		    }		
////		});
//		txtPlay.addSelectionListener(new SelectionListener() {
//
//			@Override
//			public void widgetDefaultSelected(SelectionEvent e) {
//				// TODO Auto-generated method stub
//				
//			}
//
//			@Override
//			public void widgetSelected(SelectionEvent e) {
//				System.out.println(e.toString());
//			}
//			
//			
//		});
//		
//		
//		txtPlay.addKeyListener(new KeyListener() {
//
//			public void keyPressed(KeyEvent e) {
//				System.out.println(e.character);
//				if (e.character == '=') {
//					Shell shell = Activator.getDefault().getWorkbench().
//						getActiveWorkbenchWindow().getShell();
//					PopupList list = new PopupList(shell, SWT.H_SCROLL | SWT.V_SCROLL);
//					
////					Combo list = new Combo(shell, SWT.H_SCROLL | SWT.V_SCROLL);
//					
//					// Add the items to the list
//					String[] OPTIONS = { "Create homo. syn.",
//							"Create hetero. syn.",
//							"Create mis. name",
//							"Create homonym"};
//
//					list.setItems(OPTIONS);
//					
//					// Open the list and get the selected item
//					String selected = list.open(txtPlay.getBounds());
//					
//					// Print the item to the console
//					System.out.println(selected);					
//				}
//				
//			}
//
//			public void keyReleased(KeyEvent e) {
//				// TODO Auto-generated method stub
//				
//			}
//		});
		
		populateForm();		
		initDataBindings();
	}

	private void createTree(Composite composite) {

		popNodes();
		
		treeViewer = new TreeViewer(composite, SWT.BORDER | SWT.FULL_SELECTION);
		final GridData gridData = new GridData(SWT.LEFT, SWT.FILL, false, true);
		gridData.heightHint = 166;
		treeViewer.getTree().setLayoutData(gridData);
		treeViewer.getTree().setLinesVisible(true);
		treeViewer.getTree().setHeaderVisible(false);
//		TreeColumn[] tc = treeViewer.getTree().getColumns();
				
		// create a column for field names
		TreeViewerColumn column = new TreeViewerColumn(treeViewer, SWT.NONE);
		column.getColumn().setWidth(200);
		column.getColumn().setMoveable(true);
		column.setLabelProvider(new ColumnLabelProvider() {
			public String getText(Object element) {
			    return ((Node) element).getName();
			}
		});
		
		final TextCellEditor textCellEditor = new TextCellEditor(treeViewer.getTree());
		genusCellEditor = new TextCellEditor(treeViewer.getTree());
		// create a column for field values		
		column = new TreeViewerColumn(treeViewer, SWT.NONE);
		column.getColumn().setWidth(200);
		column.getColumn().setMoveable(true);
		treeViewer.setContentProvider(new MyTreeContentProvider());
				
		// how can i be sure i'm populating this correctly?
		IObservableMap[] attributeMaps = BeansObservables.observeMaps(
				((ObservableListContentProvider) treeViewer.getContentProvider()).getKnownElements(),
				Node.class, new String[] { "value" });
		
		cellLabelProvider = new GenericObservableMapCellLabelProvider(attributeMaps, null, bindingContext);
		column.setLabelProvider(cellLabelProvider);

		column.setEditingSupport(new EditingSupport(treeViewer) {
			
			@Override
			protected boolean canEdit(Object element) {
				return true;
			}

			@Override
			protected CellEditor getCellEditor(Object element) {
				if ((((Node) element).getName()) == "Genus")
					return genusCellEditor;
				return textCellEditor;
			}

			@Override
			protected Object getValue(Object element) {
//				return ((Node) element).getValue();
				return (Node) element;
			}

			@Override
			protected void setValue(Object element, Object value) {
				((Node) element).setValue(value.toString());
				treeViewer.update(element, null);
			}

			protected void initializeCellEditorValue(CellEditor cellEditor, ViewerCell cell) {
				Node node = (Node) getValue(cell.getElement());
				cellEditor.setValue(node.getValue());
				
				// is this the Genus? then databind!
				if ((node.getName() == "Genus")) {
					
					// this gets us successfully bound in one direction
					bindingContext.bindValue(observeTxtGenus, 
							SWTObservables.observeText(genusCellEditor.getControl(), SWT.Modify),  
							new UpdateValueStrategy(
									UpdateValueStrategy.POLICY_CONVERT), null);
					
				}
			}			
		});
		treeViewer.setInput(nodes);
				
	}
	
	
	private void populateForm() {
		
		String fulltext = "";
		
		if (taxonname.getGenus() != null) {
			txtGenus.setText(taxonname.getGenus());
			txtGenus_1.setText(taxonname.getGenus());
			fulltext = taxonname.getGenus();
		}

		if (taxonname.getSpecificEpithet() != null) {
			txtSpEpi.setText(taxonname.getSpecificEpithet());
			fulltext += " " + taxonname.getSpecificEpithet();
		}

		if (taxonname.getAuthorship() != null) {
			txtAuthor.setText(taxonname.getAuthorship());
			fulltext += " " + taxonname.getAuthorship();
		}
				
		this.setPartName(taxonname.getName());
	}

	@Override
	public void init(IEditorSite site, IEditorInput input) throws PartInitException {

		if (!(input instanceof IEditorInput))
			throw new PartInitException(
					"Invalid Input: Must be IFileEditorInput");
		
		if (input.getAdapter(TaxonName.class) != null) {
			taxonname = (TaxonName) input.getAdapter(TaxonName.class);
		} else {
			taxonname = null;
		}
		
		setSite(site);
		setInput(input);
	}

	@Override
	public boolean isDirty() {
		return false;
	}

	@Override
	public boolean isSaveAsAllowed() {
		return false;
	}


	@Override
	public void doSave(IProgressMonitor monitor) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void doSaveAs() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void setFocus() {
		// TODO Auto-generated method stub
		
	}
	protected DataBindingContext initDataBindings() {
		observeTxtGenus = SWTObservables.observeText(txtGenus, SWT.Modify);
		observeTxtGenus_1 = SWTObservables.observeText(txtGenus_1, SWT.Modify);
		
		observeGenusNode = BeansObservables.observeValue(genusNode, "value");
		//
		
		bindingContext.bindValue(observeTxtGenus, observeGenusNode, null, null);
		bindingContext.bindValue(observeTxtGenus_1, observeGenusNode, null, null);		
		//
		return bindingContext;
	}


	private void popNodes() {
	    Node category = new Node("Full name", taxonname.getName(), null);
	    nodes.add(category);
	
	    genusNode = new Node("Genus", taxonname.getGenus(), category);
	    new Node("Species Epithet", taxonname.getSpecificEpithet(), category);
	
	    category = new Node("Reference", "in aaa: xxx. yyyy", null);
	    nodes.add(category);
		    
	    new Node("Publication", "aaa", category);
	    new Node("Detail", "xxx", category);
	    new Node("Year", "yyyy", category);	   		
	}
	
	class MyTreeContentProvider extends ObservableListContentProvider implements ITreeContentProvider{
		public Object[] getChildren(Object parentElement) {
			Vector subcats = ((Node) parentElement).getSubCategories();
			return subcats == null ? new Object[0] : subcats.toArray();
		}
		
		public Object getParent(Object element) {
			return ((Node) element).getParent();
		}
		
		public boolean hasChildren(Object element) {
			return ((Node) element).getSubCategories() != null;
		}
		
		public Object[] getElements(Object inputElement) {
			if (inputElement != null && inputElement instanceof Vector) {
				return ((Vector) inputElement).toArray();
			}
			return new Object[0];
		}
		
		public void dispose() {
		}
		
		public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
		}
	}
		class NameValPair {
			
			private String name;
			private String value;
			public String getName() {
				return name;
			}
			public void setName(String name) {
				this.name = name;
			}
			public String getValue() {
				return value;
			}
			public void setValue(String value) {
				this.value = value;
			}
		}
	
		class Node {
			  private NameValPair nameval = new NameValPair();
	
			  private Vector subCategories;
	
			  private Node parent;
	
			  public Node(String name, String value, Node parent) {
			    this.nameval.setName(name);
			    this.nameval.setValue(value);
			    this.parent = parent;
			    if (parent != null)
			      parent.addSubCategory(this);
			  }
	
			  public Vector getSubCategories() {
			    return subCategories;
			  }
	
			  private void addSubCategory(Node subcategory) {
			    if (subCategories == null)
			      subCategories = new Vector();
			    if (!subCategories.contains(subcategory))
			      subCategories.add(subcategory);
			  }
	
			  public String getName() {
			    return this.nameval.getName();
			  }
	
			  public String getValue() {
				    return this.nameval.getValue();
				  }
	
			  public void setValue(String value) {
					String oldValue = this.nameval.getValue();
				    this.nameval.setValue(value);
					firePropertyChange("value", oldValue, value);
			  }			  
			  
			  public Node getParent() {
			    return parent;
			  }
			  
				private PropertyChangeSupport propertyChangeSupport = new PropertyChangeSupport(
						this);

				public void addPropertyChangeListener(PropertyChangeListener listener) {
					propertyChangeSupport.addPropertyChangeListener(listener);
				}

				public void addPropertyChangeListener(String propertyName,
						PropertyChangeListener listener) {
					propertyChangeSupport.addPropertyChangeListener(propertyName,
							listener);
				}

				public void removePropertyChangeListener(PropertyChangeListener listener) {
					propertyChangeSupport.removePropertyChangeListener(listener);
				}

				public void removePropertyChangeListener(String propertyName,
						PropertyChangeListener listener) {
					propertyChangeSupport.removePropertyChangeListener(propertyName,
							listener);
				}

				protected void firePropertyChange(String propertyName, Object oldValue,
						Object newValue) {
					propertyChangeSupport.firePropertyChange(propertyName, oldValue,
							newValue);
				}
			  
			}
}	