/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.propertysheet.name;

import org.apache.log4j.Logger;
import org.eclipse.ui.views.properties.TextPropertyDescriptor;

import eu.etaxonomy.cdm.common.CdmUtils;
import eu.etaxonomy.cdm.model.name.BotanicalName;

/**
 * Property source for BotanicalName entries.
 *  
 * @author p.ciardelli
 * @created 21.05.2008
 * @version 1.0
 */
public class BotanicalNamePropertySource extends NonViralNamePropertySource {
	private static final Logger logger = Logger
			.getLogger(BotanicalNamePropertySource.class);
	
    // Property unique keys
	public static final String P_ID_REFERENCEYEAR = "referenceyear";	
    // Property display keys
	public static final String P_REFERENCEYEAR = "099:Reference Year";	
		
	public BotanicalNamePropertySource(BotanicalName name) {
		super(name);
//		addDescriptor(P_ID_REFERENCEYEAR);
	}
		
	protected void addDescriptor(String id) {
		if (id.equals(P_ID_REFERENCEYEAR)) {
			descriptors.addElement(
					new TextPropertyDescriptor(P_ID_REFERENCEYEAR, P_REFERENCEYEAR));
		}
		super.addDescriptor(id);
	}
	
	@Override
	public Object getPropertyValue(Object id) {
        if (id.equals(P_ID_NOMENCLATURAL_CODE)) {
        	return "ICBN";
        }
        if (id.equals(P_ID_REFERENCEYEAR)) {
        	return CdmUtils.Nz(name.getReferenceYear());
        }
		return super.getPropertyValue(id);
	}
}