/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.editor.description;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.forms.widgets.TableWrapLayout;

import eu.etaxonomy.cdm.model.description.Feature;
import eu.etaxonomy.cdm.model.description.TaxonDescription;
import eu.etaxonomy.taxeditor.editor.GroupComposite;
import eu.etaxonomy.taxeditor.editor.GroupCompositeLabel;

/**
 * @author p.ciardelli
 * @created 11.09.2008
 * @version 1.0
 */
public class DescriptionFeatureGroupComposite extends GroupComposite {

	private TaxonDescription description;
	private Feature feature;

	public DescriptionFeatureGroupComposite(TaxonDescriptionEditor editor, Composite parent, 
			TaxonDescription description, Feature feature) {
		
		super(editor, parent);

		this.description = description;
		this.feature = feature;
		
		TableWrapLayout	tlLayout = new TableWrapLayout();
		tlLayout.topMargin = 0;
		tlLayout.leftMargin = 10;
		setLayout(tlLayout);
		
		new GroupCompositeLabel(this, feature.getLabel());
	}
	
	public TaxonDescription getDescription() {
		return description;
	}
	
	public Feature getFeature() {
		return feature;
	}
}
