// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.editor.description;

import org.apache.log4j.Logger;
import org.eclipse.jface.action.ContributionItem;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.ui.handlers.IHandlerService;

import eu.etaxonomy.cdm.model.description.Feature;
import eu.etaxonomy.taxeditor.editor.internal.TaxeditorEditorPlugin;
import eu.etaxonomy.taxeditor.preference.PreferencesUtil;

/**
 * @author n.hoffmann
 * @created 17.04.2009
 * @version 1.0
 */
public class DynamicFeatureMenu extends ContributionItem {
	private static final Logger logger = Logger
			.getLogger(DynamicFeatureMenu.class);

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.jface.action.ContributionItem#fill(org.eclipse.swt.widgets.Menu, int)
	 */
	@Override
	public void fill(Menu menu, int index){
		final IHandlerService handlerService = (IHandlerService) TaxeditorEditorPlugin.getDefault().getWorkbench().getService(IHandlerService.class);


		for(final Feature feature : PreferencesUtil.getPreferredFeatures()){
			MenuItem menuItem = new MenuItem(menu, -1);
			menuItem.setText(feature.getLabel());
			// TODO no use for menuItem.data?
			menuItem.setData(feature);
			menuItem.addSelectionListener(new SelectionListener(){

				public void widgetDefaultSelected(SelectionEvent e) {}

				public void widgetSelected(SelectionEvent ev) {
					Event event = new Event();
					event.data = feature;
					try {
						handlerService.executeCommand("eu.etaxonomy.taxeditor.editor.description.createDescriptionElement", event);
					} catch (Exception e) {
						logger.error("Error executing command", e);
					}
				}				
			});
		}
		
	}
}
