// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.datasource.wizard;

import org.eclipse.jface.dialogs.MessageDialog;

import eu.etaxonomy.cdm.database.CdmDataSource;
import eu.etaxonomy.cdm.database.ICdmDataSource;

/**
 * @author n.hoffmann
 * @created 19.05.2009
 * @version 1.0
 */
public class CdmDataSourceH2WizardPage extends CdmDataSourceCredentialsWizardPage {
	
	/**
	 * @param pageName
	 */
	protected CdmDataSourceH2WizardPage(ICdmDataSource dataSource) {
		super("H2");
		setTitle("Enter credentials for embedded H2 database");
		this.dataSource = dataSource;
		
	}
	
	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.store.datasource.CdmDataSourceCredentialsWizardPage#createDatabaseForm()
	 */
	@Override
	public void createDatabaseForm() {
		// no more fields needed for embedded H2
	}
	

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.store.datasource.ICdmDataSourceCredentialsWizardPage#testDbConfiguration()
	 */
	public void testDbConfiguration() {
		CdmDataSource dataSource = CdmDataSource.NewH2EmbeddedInstance(
				getWizard().getDatabase(), 
				getWizard().getUsername(), 
				getWizard().getPassword()
			);
		
		try{
			dataSource.testConnection();
			MessageDialog.openConfirm(parent.getShell(), "Test successful", "Test successful");
		} catch(Exception e){
			MessageDialog.openWarning(parent.getShell(), "Test unsuccessful", "Test unsuccessful \n\n" + e.getCause());
		}	
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.store.datasource.CdmDataSourceCredentialsWizardPage#updateLocation()
	 */
	@Override
	public void updateLocation() {
		// nothing to do, no location data provided
	}
}
