// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.operations;

import java.util.UUID;

import org.apache.log4j.Logger;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.operations.IUndoContext;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;

import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
import eu.etaxonomy.cdm.model.taxon.TaxonomicTree;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * @author n.hoffmann
 * @created 23.06.2009
 * @version 1.0
 */
public class DeleteTaxonomicTreeOperation extends AbstractPostOperation {
	
	private static final Logger logger = Logger
				.getLogger(DeleteTaxonomicTreeOperation.class);
	
	private TaxonomicTree taxonomicTree;


	/**
	 * @param label
	 * @param undoContext
	 * @param taxonNode
	 * @param postOperationEnabled
	 */
	public DeleteTaxonomicTreeOperation(String label, IUndoContext undoContext,
			TaxonomicTree taxonomicTree) {
		super(label, undoContext, null);
		
		this.taxonomicTree = taxonomicTree;
		
	}



	/* (non-Javadoc)
	 * @see org.eclipse.core.commands.operations.IUndoableOperation#execute(org.eclipse.core.runtime.IProgressMonitor, org.eclipse.core.runtime.IAdaptable)
	 */
	public IStatus execute(IProgressMonitor monitor, IAdaptable info)
			throws ExecutionException {
		
		deleteTaxonomicTreeIsolated(taxonomicTree.getUuid());
		
		return postExecute(null);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.core.commands.operations.IUndoableOperation#redo(org.eclipse.core.runtime.IProgressMonitor, org.eclipse.core.runtime.IAdaptable)
	 */
	public IStatus redo(IProgressMonitor monitor, IAdaptable info)
			throws ExecutionException {
		// TODO Auto-generated method stub
		return null;
	}


	/* (non-Javadoc)
	 * @see org.eclipse.core.commands.operations.IUndoableOperation#undo(org.eclipse.core.runtime.IProgressMonitor, org.eclipse.core.runtime.IAdaptable)
	 */
	public IStatus undo(IProgressMonitor monitor, IAdaptable info)
			throws ExecutionException {
		// TODO Auto-generated method stub
		return null;
	}
	
	/**
	 * @param uuid
	 */
	private boolean deleteTaxonomicTreeIsolated(UUID uuid) {
		// get a new conversation
		ConversationHolder conversation = CdmStore.NewTransactionalConversation();
		
		TaxonomicTree taxonomicTree = CdmStore.getTaxonService().getTaxonomicTreeByUuid(uuid);
		CdmStore.getTaxonService().removeTaxonomicTree(taxonomicTree);

		// commit the conversation
		conversation.commit(true);	
		return true;
	}
}
